;####################################################################
;#                                                                  #
;#          DBF SPINNING CUBES entry by Jace / ST Knights           #
;#                                                                  #
;#             Purebasic Source                                     #
;#                                                                  #
;#             For: www.dbfinteractive.com !                        #
;#                                                                  #
;#                                                                  #
;####################################################################


Macro FastRGB(r, g, b)

  ; Faster equivalent of RGB(), although only suitable for integers

  (((r << 8 + g) << 8 ) + b)
 
EndMacro

InitSprite() 
InitSprite3D()
InitKeyboard()                  

Global xres = 800
Global yres = 600
fullscreen.b = #True

titre.s = "www.dbfinteractive.com [Cubes] Challenge entry by Jace / ST Knights"
If MessageBox_(#Null,"Would You Like To Run In Fullscreen Mode?","Start FullScreen?",#MB_YESNO | #MB_ICONQUESTION)=#IDNO
  fullscreen = #False 
EndIf
If fullscreen=#True
  window = OpenScreen( xres , yres , 32 , titre)      
  If window = 0                                            
    MessageRequester("Error", "This is fucked up, I can't open the window", 0)       
    End                                                    
  EndIf
Else
  
  If OpenWindow(0,0,0,xres,yres, titre,#PB_Window_NoGadgets | #PB_Window_ScreenCentered   ) 
   If OpenWindowedScreen(WindowID(0), 0, 0,  xres , yres , 1,0,0) =0    
     MessageRequester("Error", "This is fucked up, I can't open the window", 0)       
     End                                                    
   EndIf
  EndIf
EndIf   

;Include routs
IncludeFile "libminifmod170.pbi"
IncludeFile "linerout.pbi"
IncludeFile "3dretro.pbi"


Global angleX.f,angleY.f,angleZ.f


;buffers for 3D objects init
Dim points.p3D(0)
Dim lignes.ligne(0)
Dim faces.pQuad(0)
Dim sommets2D.p2D(0)
Dim sommets3D.p3D(0)

#nbobjets=8   ; 8 cubes

Global Dim objects.object(#nbobjets)

compte = 5
val.w = 0
val2.f= 0
val3.l = 0

For i = 0 To #nbobjets-1
  Restore cube
  ;points reading
  Read.w val
  objects(i)\nbPoints = val
  ReDim points(val)
  ReDim sommets2D(val)
  For p = 0 To objects(i)\nbPoints-1
    Read.f val2
    points(p)\x = val2
    Read.f val2
    points(p)\y = val2
    Read.f val2
    points(p)\z = val2
  Next p
  objects(i)\ptPoints = AllocateMemory(objects(i)\nbPoints*SizeOf(p3D))                           ; creating a bugger to copy the tab inside
  CopyMemory(points(),objects(i)\ptPoints,objects(i)\nbPoints*SizeOf(p3D))  ;Copy the data
  objects(i)\ptPointsT = AllocateMemory(objects(i)\nbPoints*SizeOf(p3D))                           ; creating a bugger to copy the tab inside
  CopyMemory(points(),objects(i)\ptPointsT,objects(i)\nbPoints*SizeOf(p3D))  ;Copy the data for fillng!
  objects(i)\ptPointsP = AllocateMemory(objects(i)\nbPoints*SizeOf(p2D)) 
  CopyMemory(sommets2D(),objects(i)\ptPointsP,objects(i)\nbPoints*SizeOf(p2D))
  ;lecture des lignes
  Read.w val
  objects(i)\nbLignes = val
  Dim lignes.ligne(val)
  For p=0 To objects(i)\nbLignes-1
    Read.w val
    lignes(p)\p1 = val-1
    Read.w val
    lignes(p)\p2 = val-1
  Next p  
  objects(i)\ptLignes = AllocateMemory(objects(i)\nbLignes*SizeOf(ligne))                           ; creating a bugger to copy the tab inside
  CopyMemory(lignes(),objects(i)\ptLignes,objects(i)\nbLignes*SizeOf(ligne))  ;Copy the data
  
  randomCoul.l = FastRGB(10+Random(245),10+Random(245),10+Random(245))  ;create a random color for each cube
  compte = 5
  
  ;lecture des faces
  Read.w val
  objects(i)\nbFaces = val
  Dim faces.pQuad(val)
  For p=0 To objects(i)\nbFaces-1
    Read.w val : faces(p)\p1 = val-1
    Read.w val : faces(p)\p2 = val-1
    Read.w val : faces(p)\p3 = val-1
    Read.w val : faces(p)\p4 = val-1
    Read.l val3: faces(p)\couleur = randomCoul    ; here it is random used, but we could read the color in data!
  Next p  
  objects(i)\ptFaces = AllocateMemory(objects(i)\nbFaces*SizeOf(pQuad))                           ; creating a bugger to copy the tab inside
  CopyMemory(faces(),objects(i)\ptFaces,objects(i)\nbFaces*SizeOf(pQuad))  ;Copy the data
  Read.w  val : objects(i)\type = val
  Read.f  val2 : objects(i)\angX = valf
  Read.f  val2 : objects(i)\angY = valf
  Read.f  val2 : objects(i)\angZ = valf
  Read.f  val2 : objects(i)\posX = valf
  Read.f  val2 : objects(i)\posY = valf
  Read.f  val2 : objects(i)\posZ = valf
  
Next i

;creating a sprite for shadow effect 1
CreateSprite(1,22*10,22*10,#PB_Sprite_Texture)
StartDrawing(SpriteOutput(1))
For j=0 To 21
  For i=0 To 21
    Box(i*10,j*10,10,10,RGB(64,64,64))
    Box(i*10+1,j*10+1,9,9,0)  
  Next i
Next j
StopDrawing()
CreateSprite3D(101,1)


;sprite for shadow effect 2
CreateSprite(2,22*10,22*10,#PB_Sprite_Texture)
StartDrawing(SpriteOutput(2))
For j=0 To 21
  For i=0 To 21
    Box(i*10+1,j*10+1,9,9,RGB(64,64,64))
  Next i
Next j
StopDrawing()
CreateSprite3D(102,2) 

;effect 3
CreateSprite(3,24*10,24*10,#PB_Sprite_Texture)
StartDrawing(SpriteOutput(3))
For j=0 To 11
  For i=0 To 11
    Box(i*20,j*20,20,20,RGB(64,64,64))
    Box(i*20+1,j*20+1,19,19,0)
  Next i
Next j
StopDrawing()
CreateSprite3D(103,3) 

;effect 4
CreateSprite(4,24*10,24*10,#PB_Sprite_Texture)
StartDrawing(SpriteOutput(4))
For j=0 To 11
  For i=0 To 11
    Box(i*20+1,j*20+1,19,19,RGB(64,64,64))  
  Next i
Next j
StopDrawing()
CreateSprite3D(104,4) 

;sprite for blank effect in shadow
CreateSprite(11,22*10,22*10,#PB_Sprite_Texture)
CreateSprite3D(111,11)
;scrolltext fonts sprites!
CatchSprite(12,?fontes,#PB_Sprite_Texture)
CreateSprite3D(112,12)
ZoomSprite3D(112,32,32)

sco   = 0
tptr  = 1
t.s="                              hi and welcome to this little entry for the dbf cubes challenge!!!           code by jace of st knights, music by nuke of lemon - from the amiga demo by melon dezign 'how to skin a cat'-, And is font by wayne...  "
t + "pfeeeewwww at least here is it... damn it was difficult! first i tried to make an opengl entry, but after one week of perdition, "
t + "i've thought to make a tinyc5 prod. but as it would be a bit too slow, i've decided to return to my actual favourite language: 'purebasic'. i could use the 3d engine inside, but for retro-remakes.net purposes, i've "
t + "decided to finish my own made 3d routs. seems to work nice now, but still a bit slow. hope to produce some more atari and amiga remakes soon!!!    "
t + "okay here are some greetings! dbf hellos go to : padman - hi mate! got still nasty bug with mapping, so got some plain faces!- , "
t + "benny! - it would be nice to use tinyc5 first For this! by the way i could try to make a version, all is done by hand - , "
t + "raizor - big thanx for the help, will try now to convert this entry in opengl! - , knuz - nice first opengl entry!!! -, Shockwave, Rbz, Hellfire,"
t + "Combatking0 -3 entries, wow!-, Kirl, Jim, Hotshot, Energy, KrazyK, Maracuja, blacksheep8bit -fantastic entry too!-, ... and all that I have forgotten ... "
t + "Scene greetings go to : St knights -aldyn and joker, stop sleeping!-, Hemoroids -hi Sink!-, DHS -heyyy evl-, Sector One, Triple A, Dune -nice atari st demo!-, MJJ Prods, Equinox, Orb, No Extra, Checkpoint,"
t + "Mystics Bytes, .tSCc., Paradize, Paradox, Cream, Popsy Team, Razor 1911, Bomb, TRSI..."
t + "let's wraaaaaap......                        "

;sprites effets pixels
#nbSprite = 25
Dim tabSprites(#nbSprite)
Dim tabSprites3D(#nbSprite)
Dim tabSpritesB(#nbSprite)
Dim tabSprites3DB(#nbSprite)
Structure sprPixel
  x.w
  y.w
  z.w
  noSpr.i
  alpha.w
  zoom.f
EndStructure
Dim tabPosSprites.sprPixel(#nbSprite)
Dim tabPosSprites2.sprPixel(#nbSprite)

For s.l = 0 To #nbSprite-1 
  tabSprites(s) = CreateSprite(#PB_Any,16,16,#PB_Sprite_Texture)
  StartDrawing(SpriteOutput(tabSprites(s)))
  For i=0 To 2
    For j=0 To 2
      If Random(1)
        Box(j*5,i*5,4,4,RGBA(223+Random(32),64+Random(32),32+Random(255),Random(255)))
      EndIf
    Next j
  Next i
  StopDrawing()
  tabSprites3D(s) = CreateSprite3D(#PB_Any,tabSprites(s))
  ;pixel blancs
  tabSpritesB(s) = CreateSprite(#PB_Any,16,16,#PB_Sprite_Texture)
  StartDrawing(SpriteOutput(tabSpritesB(s)))
  For i=0 To 2
    For j=0 To 2
      If Random(1)
        blanc.w = Random(255)
        Box(j*5,i*5,4,4,RGBA(blanc,blanc,blanc,Random(255)))
      EndIf
    Next j
  Next i
  StopDrawing()
  tabSprites3DB(s) = CreateSprite3D(#PB_Any,tabSpritesB(s))
Next s
zSpr.w = 11+Random(1000)
For i=0 To #nbSprite-1
  tabPosSprites(i)\x = Random(xres)-xres/2
  tabPosSprites(i)\y = Random(yres)-yres/2
  tabPosSprites(i)\z = 11+Random(100)
Next i

Dim tabPosSprites3.sprPixel(#nbSprite)


angleX = 0;(2*#PI)/180*20
angleY = 0;(2*#PI)/250*40
angleZ = 0;(2*#PI)/180*20


Global  matrice.Matrix

;initFace1()
CreateSprite(100,32,32,#PB_Sprite_Texture)
StartDrawing(SpriteOutput(100))
Box(0,0,SpriteWidth(100),SpriteHeight(100),RGB(255,128,64))
StopDrawing()
CreateSprite3D(100,100)



scale.f = 1.0
Global incPos.f = 15.0
Global Tx = 0.0
Global Ty = 0.0
Global Tz = 0.0



effetOmbrage = 0
pauseEffet = 5*60
pauseEfface = 0
pauseSprite = 0
pauseChangeSprite = 60
modePixel = 1
pauseSprite = 0
incEffetPixel = 0
effetPixel = 3
oldModePixel = 0
effetCube = 0
beatCube = 0

IncludeFile "spincube.pbi"

MiniFmod_Init(?mod,?endmod-?mod)
MiniFmod_Play() 



Repeat
  
  channel = MiniFmod_GetSynch(3) & $ffff
  If channel <> beatCube And scale < 0.85
    scale = 1.0
    incPos = 15.0
    changeCoul - 1
  EndIf
  
  ClearScreen(RGB(64,64,64)) 
  
  Start3D()
  
  ;make the 3D stuff
  calculSpin(scale)  
  ;drawSimpleObject(@objects(0),xres/2,yres/2,2)  ;for testing!
    
  ;display the shadowed cubes.
  Sprite3DBlendingMode(1,10) ; sprite en fondu!
  makeDrawPipeline(objects(),#nbobjets,xres/2+50*Cos(angleX)*Cos(angleY),yres/2+50*Sin(angleX+angleY))
  
  ;shadow mode init
  pauseEffet - 1
  If pauseEffet = 0 
    pauseEffet = 5*60
    Repeat
      new = Random(6)
    Until effetOmbrage <> new
    effetOmbrage = new
  EndIf

  ;shadow display, 4 types!
  Select effetOmbrage
    Case 1 
      effetOmbre1(1)
    Case 2
      effetOmbre1(2)
    Case 3
      If pauseEfface = 0
        StartDrawing(SpriteOutput(11))
        Box(0,0,22*10,22*10,0)
        For j=0 To 21
          d.w = Random(5)
          f.w = Random(10-d)
          Box(d*10,j*10,f*10,10,RGB(64,64,64))
          d.w = Random(5+f+d)
          f.w = Random(22-d)
          Box(d*10,j*10,f*10,10,RGB(64,64,64))
        Next j
        StopDrawing()        
        pauseEfface = 60  
      EndIf
      pauseEfface - 1
     effetOmbre1(1,#True)
    Case 4
      If pauseEfface = 0
        StartDrawing(SpriteOutput(11))
        Box(0,0,22*10,22*10,0)
        For j=0 To 10
          d = Random(7)
          f = Random(11-d)
          Box(d*20,j*20,f*20,20,RGB(64,64,64))
        Next j
        StopDrawing()        
        pauseEfface = 60  
      EndIf
      pauseEfface - 1
      effetOmbre1(2,#True)
    Case 5
      effetOmbre2(1)
    Case 6
      effetOmbre2(2)
  EndSelect
  
  ;scrolltext
  Sprite3DBlendingMode(5,6)
  cco = 0
  For cc = 0 To 25
    letter = (Asc(UCase(Mid(t.s, tptr+cc, 1)))-32)
    x = (letter % 10)*32
    y = (letter - (letter%10))/10*32
    ClipSprite3D(112,x,y,32,32)
    DisplaySprite3D(112, cco+sco, yres-32*2)
    cco = cco + 32
  Next

  sco = sco -4
  If sco < -32
    tptr = tptr + 1
    If tptr > (Len(t.s)-30)
      tptr = 1
    EndIf
    sco=sco + 32
  EndIf


  ;random pixels soomed effect

  pauseChangeSprite -1
  If pauseChangeSprite = 0
    modePixel + 1
    If modePixel = 3
      modePixel = 1
    EndIf
    pauseChangeSprite = 30
    For i=0 To #nbSprite-1  
      If modePixel = 1
        tabPosSprites(i)\noSpr = tabSprites3D(Random(#nbSprite-1))
      Else
        tabPosSprites(i)\noSpr = tabSprites3DB(Random(#nbSprite-1))
      EndIf 
    Next i
  EndIf
  
  Select effetPixel
      
    Case 1
      
      If pauseSprite = 0
        For i=0 To #nbSprite-1
          If modePixel = 1
            tabPosSprites(i)\noSpr = tabSprites3D(Random(#nbSprite-1))
          Else
            tabPosSprites(i)\noSpr = tabSprites3DB(Random(#nbSprite-1))
          EndIf 
          xSpr.w=(tabPosSprites(i)\x*xres/2)/tabPosSprites(i)\z + xres/2
          ySpr.w=(-tabPosSprites(i)\y*yres/2)/tabPosSprites(i)\z + yres/2
          tabPosSprites(i)\zoom = 16+((1000-tabPosSprites(i)\z)/1000)*64
          tabPosSprites(i)\alpha = Int(((1000-tabPosSprites(i)\z)/1000)*255)
          ZoomSprite3D(tabPosSprites(i)\noSpr,tabPosSprites(i)\zoom,tabPosSprites(i)\zoom)
          DisplaySprite3D(tabPosSprites(i)\noSpr,xSpr,ySpr,tabPosSprites(i)\alpha)
          tabPosSprites(i)\z - 1
          If tabPosSprites(i)\z<=10
            tabPosSprites(i)\z = 11+Random(1000)
          EndIf
        Next i
        pauseSprite = 60*2
        incEffetPixel + 1
        If incEffetPixel = 4
          effetPixel = 2
          effetCube = Random(5)
          incEffetPixel = 0
          pauseSprite = 0
        EndIf
      Else
        For i=0 To #nbSprite-1
          xSpr.w=(tabPosSprites(i)\x*xres/2)/tabPosSprites(i)\z + xres/2
          ySpr.w=(-tabPosSprites(i)\y*yres/2)/tabPosSprites(i)\z + yres/2
          tabPosSprites(i)\zoom = 16+((1000-tabPosSprites(i)\z)/1000)*64
          tabPosSprites(i)\alpha = Int(((1000-tabPosSprites(i)\z)/1000)*255)
          ZoomSprite3D(tabPosSprites(i)\noSpr,tabPosSprites(i)\zoom,tabPosSprites(i)\zoom)
          DisplaySprite3D(tabPosSprites(i)\noSpr,xSpr,ySpr,tabPosSprites(i)\alpha)
          tabPosSprites(i)\z - 1
          If tabPosSprites(i)\z<=10
            tabPosSprites(i)\z = 11+Random(1000)
          EndIf
        Next i
        pauseSprite - 1
      EndIf
      
    Case 2
  
      If pauseSprite = 0
         zSpr.w = 11+Random(1000)
        For i=0 To #nbSprite-1
           tabPosSprites2(i)\x = Random(Int(xres/16)-1)
           tabPosSprites2(i)\y = Random(Int(yres/16)-1)
           tabPosSprites2(i)\z = zSpr
          If modePixel = 1
            tabPosSprites2(i)\noSpr = tabSprites3D(Random(#nbSprite-1))
          Else
            tabPosSprites2(i)\noSpr = tabSprites3DB(Random(#nbSprite-1))
          EndIf
          tabPosSprites2(i)\zoom = 16+Random(64)
          tabPosSprites2(i)\alpha = 255-tabPosSprites2(i)\zoom*2
          ZoomSprite3D(tabPosSprites2(i)\noSpr,tabPosSprites2(i)\zoom,tabPosSprites2(i)\zoom)
          DisplaySprite3D(tabPosSprites2(i)\noSpr,tabPosSprites2(i)\x*16,tabPosSprites2(i)\y*16,tabPosSprites2(i)\alpha)
        Next i
        pauseSprite = 60*2
        incEffetPixel + 1
        If incEffetPixel = 6
          effetPixel = 3
          effetCube = Random(5)
          incEffetPixel = 0
          pauseSprite = 0
        EndIf
      Else
        For i=0 To #nbSprite-1
          If (tabPosSprites2(i)\alpha > 1 )
            tabPosSprites2(i)\alpha - 1
          EndIf
          ZoomSprite3D(tabPosSprites2(i)\noSpr,tabPosSprites2(i)\zoom,tabPosSprites2(i)\zoom)
          DisplaySprite3D(tabPosSprites2(i)\noSpr,tabPosSprites2(i)\x*16,tabPosSprites2(i)\y*16,tabPosSprites2(i)\alpha)
        Next i
        pauseSprite - 1
      EndIf
      
    Case 3
  
      If pauseSprite = 0
        For i=0 To #nbSprite-1
          tabPosSprites3(i)\x = Random(xres/64)*64
          tabPosSprites3(i)\y = Random(yres/64)*64
          tabPosSprites3(i)\z = 0
          If modePixel = 1
            tabPosSprites3(i)\noSpr = tabSprites3D(Random(#nbSprite-1))
          Else
            tabPosSprites3(i)\noSpr = tabSprites3DB(Random(#nbSprite-1))
          EndIf
          tabPosSprites3(i)\zoom = 64
          tabPosSprites3(i)\alpha = Random(255)
          ZoomSprite3D(tabPosSprites3(i)\noSpr,tabPosSprites3(i)\zoom,tabPosSprites3(i)\zoom)
          DisplaySprite3D(tabPosSprites3(i)\noSpr,tabPosSprites3(i)\x,tabPosSprites3(i)\y,tabPosSprites3(i)\alpha)
        Next i
        pauseSprite = 60*2
        incEffetPixel + 1
        If incEffetPixel = 6
          effetPixel = 1
          effetCube = Random(5)
          incEffetPixel = 0
          pauseSprite = 0
        EndIf
      Else
        For i=0 To #nbSprite-1
          If (tabPosSprites3(i)\alpha > 1 )
            tabPosSprites3(i)\alpha - 1
          EndIf
          
          ;tabPosSprites(i)\y + 1
          ZoomSprite3D(tabPosSprites3(i)\noSpr,tabPosSprites3(i)\zoom,tabPosSprites3(i)\zoom)
          DisplaySprite3D(tabPosSprites3(i)\noSpr,tabPosSprites3(i)\x,tabPosSprites3(i)\y,tabPosSprites3(i)\alpha)
        Next i
        pauseSprite - 1
      EndIf
  EndSelect
  
  ;The spinnig cubes!!!
  calculSpin(scale*0.8)
  Sprite3DBlendingMode(5,6) ; sprite en fondu!
  makeDrawPipeline(objects(),#nbobjets,xres/2-50,yres/2-70,effetCube) ;make a Z-buffer and display all
  
 
  Stop3D()
  
  
  scale - 0.005
  
  incPos - 0.2
  angleX = incAngle(angleX, (2*#PI)/310)
  angleY = incAngle(angleY, (2*#PI)/250)
  angleZ = incAngle(angleZ, (2*#PI)/360)
  
  FlipBuffers()
  If fullscreen=#False
    Event = WaitWindowEvent(0)
  EndIf
  
  ExamineKeyboard()  

Until KeyboardPushed (#PB_Key_Escape)
MiniFmod_Stop()
MiniFmod_Free()
End
 
DataSection
  cube:
  ;points
  #tCube = 50.0*1.1
  Data.w  8
  Data.f  -#tCube,#tCube,#tCube,   #tCube,#tCube,#tCube,  #tCube,#tCube,-#tCube,   -#tCube,#tCube,-#tCube
  Data.f  -#tCube,-#tCube,#tCube,    #tCube,-#tCube,#tCube,   #tCube,-#tCube,-#tCube,    -#tCube,-#tCube,-#tCube
  ;lignes
;           v0
;   v3               v1
;           v2
;   
;   
;           v4
;   v7               v5
;           v6
  Data.w  12
  Data.w  1,2,  2,3,  3,4,  4,1,  5,6,  6,7,  7,8,  8,5
  Data.w  1,5,  4,8,  2,6,  3,7
  ;faces
  Data.w  6
  Data.w  1,2,3,4
  Data.l  FastRGB(255,255,255)  ;face color
  Data.w  4,3,7,8
  Data.l  FastRGB(255,0,255)
  Data.w  3,2,6,7
  Data.l  FastRGB(0,255,255)
  Data.w  2,1,5,6
  Data.l  FastRGB(255,255,0)
  Data.w  1,4,8,5
  Data.l  FastRGB(0,0,255)
  Data.w  5,8,7,6
  Data.l  FastRGB(255,0,0)
  Data.w  2
  Data.f  0,0,0,  0,0,0   ;angle et position
mod: IncludeBinary "how2.xm" 
endmod:
fontes: IncludeBinary "fontes_cube.bmp"
EndDataSection

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 6
; Folding = +
; EnableXP
; UseIcon = cube.ico
; Executable = DBF-[cube]-Jace-STKnights[preview].exe